/*
  Copyright (c) 2017, University of Warsaw
  All rights reserved.
  <p>
  Redistribution and use in source and binary forms, with or without modification, are permitted
  provided that the following conditions are met:
  <p>
  1. Redistributions of source code must retain the above copyright notice, this list of
  conditions and the following disclaimer.
  <p>
  2. Redistributions in binary form must reproduce the above copyright notice, this list of
  conditions and the following disclaimer in the documentation and/or other materials provided
  with the distribution.
  <p>
  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
  WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

package pl.edu.mimuw.cloudatlas.datamodel;

import pl.edu.mimuw.cloudatlas.datamodel.attribute.Attribute;
import pl.edu.mimuw.cloudatlas.datamodel.attribute.AttributesMap;
import pl.edu.mimuw.cloudatlas.datamodel.value.Value;
import pl.edu.mimuw.cloudatlas.datamodel.value.ValueInt;
import pl.edu.mimuw.cloudatlas.datamodel.value.ValueString;
import pl.edu.mimuw.cloudatlas.datamodel.value.ValueTime;

import java.io.PrintStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map.Entry;

/**
 * A zone management information. This object is a single node in a zone hierarchy. It stores zone attributes as well as
 * references to its father and sons in the tree.
 * While ZMI is creating owner/creator must be provided.
 */
public class ZMI implements Cloneable, Serializable {
    /**
     * Field #attributes must contain following (at least) attributes:
     * <ul>
     * <li>level: #ValueInt - the level of the zone in hierarchy; for root level equals 0</li>
     * <li>name: #ValueString - the local zone name; for root :=  null</li>
     * <li>owner: #ValueString - full/global name of the singleton whose node generated this ZMI</li>
     * <li>timestamp: #ValueTime - the thie the ZMI was generated by the owner</li>
     * <li>contacts: #ValueList of #ValueContact - a small set of contacts nodes (machines) it the zone</li>
     * <li>cardinality: #ValueInt - the total numer of nodes (machines) in the zone.</li>
     * </ul>
     */
    private final AttributesMap attributes = new AttributesMap();

    private final List<ZMI> sons = new ArrayList<>();

    private ZMI father;

    /**
     * Creates a new ZMI with no father (the root zone) and empty sons list.
     */
    public ZMI() {

        this(null);
    }

    /**
     * Creates a new ZMI with the specified node as a father and empty sons list. This method does not perform any
     * operation on the <code>father</code>. Especially, setting this object as a <code>father</code>'s son must be done
     * separately.
     * Method assumes that all sanity checks are already done externally.
     * <p>
     * Obligatory attributes are automatically added:
     * <ul>
     * <li>owner, local_name form method argument</li>
     * <li>contacts is empty list</li>,
     * <li>level is calculated basing on father</li>
     * <li>cardinality set to one</li>
     * <li>timestamp is time now</li>
     * </ul>
     *
     * @param father a father of this ZMI
     * @see #addSon(ZMI)
     */
    public ZMI(ZMI father) {
        this.father = father;
    }

    /** Helper method to go up in tree. */
    public static PathName generatePathName(ZMI zmi) {
        String name = ((ValueString) zmi.getAttributes().get("name")).getValue();
        return zmi.getFather() == null ? PathName.ROOT : generatePathName(zmi.getFather()).levelDown(name);
    }

    /**
     * Collect all paths in DFS order.
     */
    public static void getZonesList(ZMI zmi, List<String> list) {
        list.add(zmi.getFullPath().toString());
        if (!zmi.getSons().isEmpty()) {
            for (ZMI son : zmi.getSons()) {
                getZonesList(son, list);
            }
        }
    }

    public static ZMI findZmi(PathName path, ZMI root) {
        if (path.getDepth() == 0) return root;
        String next = path.getFirst();
        if (!root.getSons().isEmpty()) {
            for (ZMI son : root.getSons()) {
                if (son.getAttributes().get("name").toString().equals(next)) return findZmi(path.cutRoot(), son);
            }
        }
        // PathName points to son but there's no such zone... fail.
        return null;
    }

    /**
     * Gets a map of all the attributes stored in this ZMI.
     *
     * @return map of attributes
     */
    public AttributesMap getAttributes() {

        return attributes;
    }

    /**
     * Gets a father of this ZMI in a tree.
     *
     * @return a father of this ZMI or <code>null</code> if this is the root zone
     */
    public ZMI getFather() {

        return father;
    }

    /**
     * Sets or changes a father of this ZMI in a tree. This method does not perform any operation on the
     * <code>father</code>. Especially, setting this object as a <code>father</code>'s son must be done separately.
     *
     * @param father a new father for this ZMI
     * @see #addSon(ZMI)
     */
    public void setFather(ZMI father) {

        this.father = father;
    }

    /**
     * Gets a list of sons of this ZMI in a tree. Modifying a return value will cause an exception.
     *
     * @return
     */
    public List<ZMI> getSons() {

        return Collections.unmodifiableList(sons);
    }

    /**
     * Adds the specified ZMI to the list of sons of this ZMI. This method does not perform any operation on a
     * <code>son</code>. Especially, setting this object as a <code>son</code>'s father must be done separately.
     *
     * @param son
     * @see #setFather(ZMI)
     */
    public void addSon(ZMI son) {
        if (!sons.contains(son))
            sons.add(son);
    }

    /**
     * Removes the specified ZMI from the list of sons of this ZMI. This method does not perform any operation on a
     * <code>son</code>. Especially, its father remains unchanged.
     *
     * @param son
     * @see #setFather(ZMI)
     */
    public void removeSon(ZMI son) {
        if (sons.contains(son))
            sons.remove(son);
    }

    /**
     * Prints recursively in a prefix order (starting from this ZMI) a whole tree with all the attributes.
     *
     * @param stream a destination stream
     * @see #toString()
     */
    public void printAttributes(PrintStream stream) {
        stream.println(getFullName());
        for (Entry<Attribute, Value> entry : attributes)
            stream.println("\t" + entry.getKey() + " : " + entry.getValue().getType() + " = " + entry.getValue());
        stream.println();
        for (ZMI son : sons)
            son.printAttributes(stream);
    }

    /**
     * Creates an independent copy of a whole hierarchy. A returned ZMI has the same reference as a father (but the
     * father does not have a reference to it as a son). For the root zone, the copy is completely independent, since
     * its father is <code>null</code>.
     *
     * @return a deep copy of this ZMI
     */
    @Override
    public ZMI clone() {
        // Here we can pass null as owner and localName because we copy all attributes in next step
        ZMI result = new ZMI(father);
        result.attributes.add(attributes.clone());
        for (ZMI son : sons) {
            ZMI sonClone = son.clone();
            result.sons.add(sonClone);
            sonClone.father = result;
        }
        return result;
    }

    /**
     * Prints a textual representation of this ZMI. It contains only attributes of this node.
     *
     * @return a textual representation of this object
     * @see #printAttributes(PrintStream)
     */
    @Override
    public String toString() {

        return attributes.toString();
    }

    /**
     * Get full/global name of the zone.
     */
    public String getFullName() {
        return getFullPath().toString();
    }

    /**
     * Get full path name of this zone.
     *
     * @return path name object
     */
    public PathName getFullPath() {
        return generatePathName(this);
    }

    /**
     * Get ZMI local name.
     *
     * @return local name
     * @since Assignment-2
     */
    public String getLocalName() {
        return ((ValueString) attributes.get("name")).getValue();
    }

    /**
     * Get ZMI creation time.
     *
     * @return local name
     * @since Assignment-2
     */
    public long getTimestamp() {
        return ((ValueTime) attributes.get("timestamp")).getValue();
    }

    /** Get ZMI's level. */
    public int getLevel() {
        return ((ValueInt) attributes.get("level")).getValue().intValue();
    }

    /**
     * Get short info about ZMI.
     * Note: required attributes: name, owner, timestamp
     */
    public String info() {
        return String.format("(name: %s, owner: %s, timestamp: %s", attributes.get("name").toString(), attributes.get("owner"), attributes.get("timestamp"));
    }
}
